#!/usr/bin/env runhaskell

import RecipeCost

-- * Example (in french for now)
eau = Ingredient "Eau" 0.003
eauDemineralisee = Ingredient "Eau déminéralisée" 0.34
savonMarseille = Ingredient "Savon de Marseille" 3.36
bicarbonate = Ingredient "Bicarbonate de soude" 3.81
vinaigreBlanc = Ingredient "Vinaigre blanc" 0.36
cremeIsigny = Ingredient "Crème fraîche d'Isigny AOP" 7.05
sel = Ingredient "Sel" 1.10
grosSel = Ingredient "Gros sel" 0.52
argileBlanche = Ingredient "Argile blanche" 40.80
huileMenthe = Ingredient "Huille essentielle de menthe poivrée" 0.75
citron = Ingredient "Citron jaune" 2.99

lessive :: Recipe
lessive = Recipe "Lessive"
                 [ eau → 2.5
                 , savonMarseille → 0.1
                 , bicarbonate → 0.016
                 , vinaigreBlanc → 0.03
                 ]
                 2.5
                 30

beurre = Recipe "Beurre"
                [ cremeIsigny → 0.4
                , sel → 0.005
                ]
                0.4
                0

dentifrice = Recipe "Dentifrice"
             [ argileBlanche → 0.016
             , bicarbonate → 0.0015
             , huileMenthe → 0.15
             , eau → 0.03
             ]
             0
             14

produitVaisselle = Recipe "Produit Vaisselle"
                   [ citron → 0.395
                   , sel → 0.2
                   , eauDemineralisee → 0.4
                   , vinaigreBlanc → 0.1
                   ]
                   0.65
                   0

main = do
    putStrLn "Calcul du coût des recettes\n"
    putStrLn "* Lessive :"
    print lessive
    let lessiveTotalCost = recipeCost lessive
        lessiveUnitCost = unitCost lessive lessiveTotalCost
        lessiveUseCost = useCost lessive lessiveTotalCost
    putStrLn $ "  * Prix Total = " ++ show lessiveTotalCost ++ "€"
    putStrLn $ "  * Prix au litre = " ++ show lessiveUnitCost ++ "€"
    putStrLn $ "  * Prix par utilisation = " ++ show lessiveUseCost ++ "€"

